<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GerarReferenciaMB StructType
 * @subpackage Structs
 */
class GerarReferenciaMB extends AbstractStructBase
{
    /**
     * The textoChave
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $textoChave;
    /**
     * The textoNome
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $textoNome;
    /**
     * The textoDescricao
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $textoDescricao;
    /**
     * The textoObservacoes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $textoObservacoes;
    /**
     * The textoTelefone
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $textoTelefone;
    /**
     * The textoEmail
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $textoEmail;
    /**
     * The totalDocumento
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $totalDocumento;
    /**
     * The configuracaoEasyPay
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConfigEasyPay
     */
    public $configuracaoEasyPay;
    /**
     * Constructor method for GerarReferenciaMB
     * @uses GerarReferenciaMB::setTextoChave()
     * @uses GerarReferenciaMB::setTextoNome()
     * @uses GerarReferenciaMB::setTextoDescricao()
     * @uses GerarReferenciaMB::setTextoObservacoes()
     * @uses GerarReferenciaMB::setTextoTelefone()
     * @uses GerarReferenciaMB::setTextoEmail()
     * @uses GerarReferenciaMB::setTotalDocumento()
     * @uses GerarReferenciaMB::setConfiguracaoEasyPay()
     * @param string $textoChave
     * @param string $textoNome
     * @param string $textoDescricao
     * @param string $textoObservacoes
     * @param string $textoTelefone
     * @param string $textoEmail
     * @param float $totalDocumento
     * @param \StructType\ConfigEasyPay $configuracaoEasyPay
     */
    public function __construct($textoChave = null, $textoNome = null, $textoDescricao = null, $textoObservacoes = null, $textoTelefone = null, $textoEmail = null, $totalDocumento = null, \StructType\ConfigEasyPay $configuracaoEasyPay = null)
    {
        $this
            ->setTextoChave($textoChave)
            ->setTextoNome($textoNome)
            ->setTextoDescricao($textoDescricao)
            ->setTextoObservacoes($textoObservacoes)
            ->setTextoTelefone($textoTelefone)
            ->setTextoEmail($textoEmail)
            ->setTotalDocumento($totalDocumento)
            ->setConfiguracaoEasyPay($configuracaoEasyPay);
    }
    /**
     * Get textoChave value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTextoChave()
    {
        return isset($this->textoChave) ? $this->textoChave : null;
    }
    /**
     * Set textoChave value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $textoChave
     * @return \StructType\GerarReferenciaMB
     */
    public function setTextoChave($textoChave = null)
    {
        // validation for constraint: string
        if (!is_null($textoChave) && !is_string($textoChave)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($textoChave)), __LINE__);
        }
        if (is_null($textoChave) || (is_array($textoChave) && empty($textoChave))) {
            unset($this->textoChave);
        } else {
            $this->textoChave = $textoChave;
        }
        return $this;
    }
    /**
     * Get textoNome value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTextoNome()
    {
        return isset($this->textoNome) ? $this->textoNome : null;
    }
    /**
     * Set textoNome value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $textoNome
     * @return \StructType\GerarReferenciaMB
     */
    public function setTextoNome($textoNome = null)
    {
        // validation for constraint: string
        if (!is_null($textoNome) && !is_string($textoNome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($textoNome)), __LINE__);
        }
        if (is_null($textoNome) || (is_array($textoNome) && empty($textoNome))) {
            unset($this->textoNome);
        } else {
            $this->textoNome = $textoNome;
        }
        return $this;
    }
    /**
     * Get textoDescricao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTextoDescricao()
    {
        return isset($this->textoDescricao) ? $this->textoDescricao : null;
    }
    /**
     * Set textoDescricao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $textoDescricao
     * @return \StructType\GerarReferenciaMB
     */
    public function setTextoDescricao($textoDescricao = null)
    {
        // validation for constraint: string
        if (!is_null($textoDescricao) && !is_string($textoDescricao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($textoDescricao)), __LINE__);
        }
        if (is_null($textoDescricao) || (is_array($textoDescricao) && empty($textoDescricao))) {
            unset($this->textoDescricao);
        } else {
            $this->textoDescricao = $textoDescricao;
        }
        return $this;
    }
    /**
     * Get textoObservacoes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTextoObservacoes()
    {
        return isset($this->textoObservacoes) ? $this->textoObservacoes : null;
    }
    /**
     * Set textoObservacoes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $textoObservacoes
     * @return \StructType\GerarReferenciaMB
     */
    public function setTextoObservacoes($textoObservacoes = null)
    {
        // validation for constraint: string
        if (!is_null($textoObservacoes) && !is_string($textoObservacoes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($textoObservacoes)), __LINE__);
        }
        if (is_null($textoObservacoes) || (is_array($textoObservacoes) && empty($textoObservacoes))) {
            unset($this->textoObservacoes);
        } else {
            $this->textoObservacoes = $textoObservacoes;
        }
        return $this;
    }
    /**
     * Get textoTelefone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTextoTelefone()
    {
        return isset($this->textoTelefone) ? $this->textoTelefone : null;
    }
    /**
     * Set textoTelefone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $textoTelefone
     * @return \StructType\GerarReferenciaMB
     */
    public function setTextoTelefone($textoTelefone = null)
    {
        // validation for constraint: string
        if (!is_null($textoTelefone) && !is_string($textoTelefone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($textoTelefone)), __LINE__);
        }
        if (is_null($textoTelefone) || (is_array($textoTelefone) && empty($textoTelefone))) {
            unset($this->textoTelefone);
        } else {
            $this->textoTelefone = $textoTelefone;
        }
        return $this;
    }
    /**
     * Get textoEmail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTextoEmail()
    {
        return isset($this->textoEmail) ? $this->textoEmail : null;
    }
    /**
     * Set textoEmail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $textoEmail
     * @return \StructType\GerarReferenciaMB
     */
    public function setTextoEmail($textoEmail = null)
    {
        // validation for constraint: string
        if (!is_null($textoEmail) && !is_string($textoEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($textoEmail)), __LINE__);
        }
        if (is_null($textoEmail) || (is_array($textoEmail) && empty($textoEmail))) {
            unset($this->textoEmail);
        } else {
            $this->textoEmail = $textoEmail;
        }
        return $this;
    }
    /**
     * Get totalDocumento value
     * @return float|null
     */
    public function getTotalDocumento()
    {
        return $this->totalDocumento;
    }
    /**
     * Set totalDocumento value
     * @param float $totalDocumento
     * @return \StructType\GerarReferenciaMB
     */
    public function setTotalDocumento($totalDocumento = null)
    {
        $this->totalDocumento = $totalDocumento;
        return $this;
    }
    /**
     * Get configuracaoEasyPay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConfigEasyPay|null
     */
    public function getConfiguracaoEasyPay()
    {
        return isset($this->configuracaoEasyPay) ? $this->configuracaoEasyPay : null;
    }
    /**
     * Set configuracaoEasyPay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ConfigEasyPay $configuracaoEasyPay
     * @return \StructType\GerarReferenciaMB
     */
    public function setConfiguracaoEasyPay(\StructType\ConfigEasyPay $configuracaoEasyPay = null)
    {
        if (is_null($configuracaoEasyPay) || (is_array($configuracaoEasyPay) && empty($configuracaoEasyPay))) {
            unset($this->configuracaoEasyPay);
        } else {
            $this->configuracaoEasyPay = $configuracaoEasyPay;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GerarReferenciaMB
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
